contrib/download-frozen-image-v2.sh
351074ed
 #!/bin/bash
 set -e
 
 # hello-world                      latest              ef872312fe1b        3 months ago        910 B
 # hello-world                      latest              ef872312fe1bbc5e05aae626791a47ee9b032efa8f3bda39cc0be7b56bfe59b9   3 months ago        910 B
 
 # debian                           latest              f6fab3b798be        10 weeks ago        85.1 MB
 # debian                           latest              f6fab3b798be3174f45aa1eb731f8182705555f89c9026d8c1ef230cbf8301dd   10 weeks ago        85.1 MB
 
b5763f8f
 if ! command -v curl &> /dev/null; then
 	echo >&2 'error: "curl" not found!'
 	exit 1
 fi
 
351074ed
 usage() {
359d0c24
 	echo "usage: $0 dir image[:tag][@digest] ..."
 	echo "       $0 /tmp/old-hello-world hello-world:latest@sha256:8be990ef2aeb16dbcb9271ddfe2610fa6658d13f6dfb8bc72074cc1ca36966a7"
351074ed
 	[ -z "$1" ] || exit "$1"
 }
 
 dir="$1" # dir for building tar in
 shift || usage 1 >&2
 
 [ $# -gt 0 -a "$dir" ] || usage 2 >&2
 mkdir -p "$dir"
 
27aab3ac
 # hacky workarounds for Bash 3 support (no associative arrays)
 images=()
 rm -f "$dir"/tags-*.tmp
 # repositories[busybox]='"latest": "...", "ubuntu-14.04": "..."'
351074ed
 
 while [ $# -gt 0 ]; do
 	imageTag="$1"
 	shift
 	image="${imageTag%%[:@]*}"
359d0c24
 	imageTag="${imageTag#*:}"
 	digest="${imageTag##*@}"
 	tag="${imageTag%%@*}"
7617ec17
 
359d0c24
 	# add prefix library if passed official image
 	if [[ "$image" != *"/"* ]]; then
 		image="library/$image"
 	fi
ca8fa6e4
 
359d0c24
 	imageFile="${image//\//_}" # "/" can't be in filenames :)
7617ec17
 
359d0c24
 	token="$(curl -sSL "https://auth.docker.io/token?service=registry.docker.io&scope=repository:$image:pull" | jq --raw-output .token)"
7617ec17
 
359d0c24
 	manifestJson="$(curl -sSL -H "Authorization: Bearer $token" "https://registry-1.docker.io/v2/$image/manifests/$digest")"
 	if [ "${manifestJson:0:1}" != '{' ]; then
 		echo >&2 "error: /v2/$image/manifests/$digest returned something unexpected:"
 		echo >&2 "  $manifestJson"
351074ed
 		exit 1
 	fi
7617ec17
 
359d0c24
 	layersFs=$(echo "$manifestJson" | jq --raw-output '.fsLayers | .[] | .blobSum')
 
 	IFS=$'\n'
927b334e
 	# bash v4 on Windows CI requires CRLF separator
c07e79fa
 	if [ "$(go env GOHOSTOS)" = 'windows' ]; then
 		major=$(echo ${BASH_VERSION%%[^0.9]} | cut -d. -f1)
 		if [ "$major" -ge 4 ]; then
 			IFS=$'\r\n'
 		fi
927b334e
 	fi
359d0c24
 	layers=( ${layersFs} )
351074ed
 	unset IFS
7617ec17
 
359d0c24
 	history=$(echo "$manifestJson" | jq '.history | [.[] | .v1Compatibility]')
 	imageId=$(echo "$history" | jq --raw-output .[0] | jq --raw-output .id)
 
ca8fa6e4
 	if [ -s "$dir/tags-$imageFile.tmp" ]; then
 		echo -n ', ' >> "$dir/tags-$imageFile.tmp"
27aab3ac
 	else
 		images=( "${images[@]}" "$image" )
 	fi
ca8fa6e4
 	echo -n '"'"$tag"'": "'"$imageId"'"' >> "$dir/tags-$imageFile.tmp"
7617ec17
 
359d0c24
 	echo "Downloading '${image}:${tag}@${digest}' (${#layers[@]} layers)..."
 	for i in "${!layers[@]}"; do
 		imageJson=$(echo "$history" | jq --raw-output .[${i}])
 		imageId=$(echo "$imageJson" | jq --raw-output .id)
 		imageLayer=${layers[$i]}
 
351074ed
 		mkdir -p "$dir/$imageId"
 		echo '1.0' > "$dir/$imageId/VERSION"
7617ec17
 
359d0c24
 		echo "$imageJson" > "$dir/$imageId/json"
7617ec17
 
351074ed
 		# TODO figure out why "-C -" doesn't work here
 		# "curl: (33) HTTP server doesn't seem to support byte ranges. Cannot resume."
 		# "HTTP/1.1 416 Requested Range Not Satisfiable"
 		if [ -f "$dir/$imageId/layer.tar" ]; then
 			# TODO hackpatch for no -C support :'(
 			echo "skipping existing ${imageId:0:12}"
 			continue
 		fi
05b05a35
 		token="$(curl -sSL "https://auth.docker.io/token?service=registry.docker.io&scope=repository:$image:pull" | jq --raw-output .token)"
359d0c24
 		curl -SL --progress -H "Authorization: Bearer $token" "https://registry-1.docker.io/v2/$image/blobs/$imageLayer" -o "$dir/$imageId/layer.tar" # -C -
351074ed
 	done
 	echo
 done
 
 echo -n '{' > "$dir/repositories"
 firstImage=1
27aab3ac
 for image in "${images[@]}"; do
ca8fa6e4
 	imageFile="${image//\//_}" # "/" can't be in filenames :)
359d0c24
 	image="${image#library\/}"
ca8fa6e4
 
351074ed
 	[ "$firstImage" ] || echo -n ',' >> "$dir/repositories"
 	firstImage=
 	echo -n $'\n\t' >> "$dir/repositories"
ca8fa6e4
 	echo -n '"'"$image"'": { '"$(cat "$dir/tags-$imageFile.tmp")"' }' >> "$dir/repositories"
351074ed
 done
 echo -n $'\n}\n' >> "$dir/repositories"
 
27aab3ac
 rm -f "$dir"/tags-*.tmp
 
351074ed
 echo "Download of images into '$dir' complete."
 echo "Use something like the following to load the result into a Docker daemon:"
 echo "  tar -cC '$dir' . | docker load"